import 'server-only';
import { gql } from 'apollo-server-micro';
import { gameTypeDefs, gameResolvers } from './game';
import { mergeTypeDefs } from '@graphql-tools/merge';
import { makeExecutableSchema } from '@graphql-tools/schema';

export const typeDefs = mergeTypeDefs([
  gameTypeDefs
]);

export const resolvers = [
  gameResolvers
];

export const schema = makeExecutableSchema({
  typeDefs,
  resolvers
});