import { gql } from "apollo-server-micro";
import { DocumentNode } from "graphql";

export type Paginated<T> = {
  edges: { node: T }[];
  pageInfo:{
    startCursor:string|null;
    endCursor:string|null;
    hasNextPage:boolean;
    hasPreviousPage:boolean;
  };
};

export const paginationQuery = (nodeDefs:DocumentNode|string) => {
  return `
    edges {
      cursor
      node {
        ${nodeDefs}
      }
    }
    
    pageInfo {
      startCursor
      endCursor
      hasNextPage
      hasPreviousPage
    }
  `;
};